#include <new.h>
#include "UMarshal.h"
#include "Message.h"
#include "MsgDlg.h"

CMessageDialog* CMessageDialog::psThis;

unsigned long __RPC_USER  PMessageDialog_UserSize(
    ULONG __RPC_FAR * pFlags, ULONG StartingSize,
    PMessageDialog  __RPC_FAR *pMyObj)
{
    return static_cast<CMarshaledDialog*>(*pMyObj)->
                                    UserSize(pFlags, StartingSize);
}

unsigned char __RPC_FAR * __RPC_USER  PMessageDialog_UserMarshal(
    ULONG __RPC_FAR * pFlags, UCHAR __RPC_FAR * pBuffer,
    PMessageDialog  __RPC_FAR * pMyObj)
{
    return static_cast<CMarshaledDialog*>(*pMyObj)->
	                                  UserMarshal(pFlags, pBuffer);
}

unsigned char __RPC_FAR * __RPC_USER  PMessageDialog_UserUnmarshal(
    ULONG __RPC_FAR * pFlags, UCHAR __RPC_FAR * pBuffer,
    PMessageDialog  __RPC_FAR *       pMyObj)
{
    WCHAR* message = reinterpret_cast<WCHAR*>(pBuffer);
    WCHAR* address = reinterpret_cast<WCHAR*>(pBuffer +
                            sizeof(WCHAR) * (wcslen(message) + 1));
    *pMyObj = new(::CoTaskMemAlloc(sizeof(CMarshaledDialog))) 
                                CMarshaledDialog(message, address);
    return (unsigned char __RPC_FAR*)(pBuffer + sizeof(WCHAR) * 
                              (wcslen(message) + wcslen(address)));
}

void __RPC_USER  PMessageDialog_UserFree(
    ULONG __RPC_FAR *pFlags, PMessageDialog __RPC_FAR *pMyObj) { }
 