#ifndef __SIMPLEMESSAGE_H_
#define __SIMPLEMESSAGE_H_

#include "Resrc.h"       // main symbols

class ATL_NO_VTABLE CSimpleMessage : 
    public CComObjectRootEx<CComMultiThreadModel>,
    public CComCoClass<CSimpleMessage, &CLSID_SimpleMessage>,
    public ISimpleMessage
{
public:
    CSimpleMessage() 	{ }

DECLARE_REGISTRY_RESOURCEID(IDR_SIMPLEMESSAGE)
BEGIN_COM_MAP(CSimpleMessage)
    COM_INTERFACE_ENTRY(ISimpleMessage)
END_COM_MAP()

    STDMETHOD(ShowDialog)(/*[in]*/ CMessageDialog* pDialog)
    {
        pDialog->Show();                // do NOT call _Module.Lock
        return S_OK;
    }
};
#endif //__SIMPLEMESSAGE_H_
