// TLibBind.h : Declaration of the CTypeLibBinder

#ifndef __TLIBBIND_H_
#define __TLIBBIND_H_


///////////////////////////////////////////////////////////
// CTypeLibBinder

class CTypeLibBinder
{
public:

    HRESULT BindToTypeLib(LPOLESTR pszDisplayName, 
                          ITypeLib** ppTypeLib);

protected:
    bool IsGUID(LPOLESTR pszDisplayName);
    ITypeLib* LoadFromGUID(LPOLESTR pszGUID);
    ITypeLib* LoadFromFile(LPOLESTR pszFileName);
};




#endif

