#include "exmodule.h"
__declspec(dllimport) CExeModule _Module;
#include "MsgDlg.h"

class CMarshaledDialog : public CMessageDialog
{
public:
    CMarshaledDialog(WCHAR* message, WCHAR* address)
    {
        mMessageText = reinterpret_cast<WCHAR*>(
          ::CoTaskMemAlloc(sizeof(WCHAR) * (wcslen(message) + 1)));
        wcscpy(mMessageText, message);
        mAddress = reinterpret_cast<WCHAR*>(
          ::CoTaskMemAlloc(sizeof(WCHAR) * (wcslen(address) + 1)));
        wcscpy(mAddress, address);
    }
    unsigned long UserSize(ULONG* pFlags, ULONG StartingSize)
    {
        return StartingSize + 
            sizeof(WCHAR) * (wcslen(mMessageText) + 1) +
            sizeof(WCHAR) * (wcslen(mAddress) + 1);
    }
    unsigned char* UserMarshal(ULONG* pFlags, UCHAR* pBuffer)
    {
        wcscpy((WCHAR*)pBuffer, mMessageText);
        pBuffer += sizeof(WCHAR) * (wcslen(mMessageText) + 1);
        wcscpy((WCHAR*)pBuffer, mAddress);
        pBuffer += sizeof(WCHAR) * (wcslen(mAddress) + 1);
        return (unsigned char __RPC_FAR*)(pBuffer); // buffer end
    }
};

